

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.DataStore &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Python programs and modules" href="index.html" />
    <link rel="next" title="pywws.TimeZone" href="pywws.TimeZone.html" />
    <link rel="prev" title="pywws.device_pyusb" href="pywws.device_pyusb.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.TimeZone.html" title="pywws.TimeZone"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="pywws.device_pyusb.html" title="pywws.device_pyusb"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="pywws-datastore">
<h1>pywws.DataStore<a class="headerlink" href="#pywws-datastore" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>This module is at the core of my weather station software. It stores data on disc, but without the overhead of a full scale database system. I have designed it to run on a small memory machine such as my Asus router. To minimise memory usage it only loads one day&#8217;s worth of data at a time into memory.</p>
<p>From a &#8220;user&#8221; point of view, the data is accessed as a cross between a list and a dictionary. Each data record is indexed by a <tt class="docutils literal"><span class="pre">datetime</span></tt> object (dictionary behaviour), but records are stored in order and can be accessed as slices (list behaviour).</p>
<p>For example, to access the hourly data for Christmas day 2009, one might do the following:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>
<span class="kn">import</span> <span class="nn">DataStore</span>
<span class="n">hourly</span> <span class="o">=</span> <span class="n">DataStore</span><span class="o">.</span><span class="n">hourly_store</span><span class="p">(</span><span class="s">&#39;weather_data&#39;</span><span class="p">)</span>
<span class="k">for</span> <span class="n">data</span> <span class="ow">in</span> <span class="n">hourly</span><span class="p">[</span><span class="n">datetime</span><span class="p">(</span><span class="mi">2009</span><span class="p">,</span> <span class="mi">12</span><span class="p">,</span> <span class="mi">25</span><span class="p">):</span><span class="n">datetime</span><span class="p">(</span><span class="mi">2009</span><span class="p">,</span> <span class="mi">12</span><span class="p">,</span> <span class="mi">26</span><span class="p">)]:</span>
    <span class="k">print</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">],</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;temp_out&#39;</span><span class="p">]</span>
</pre></div>
</div>
<p>The module provides five classes to store different data. <tt class="docutils literal"><span class="pre">data_store</span></tt> takes &#8220;raw&#8221; data from the weather station; <tt class="docutils literal"><span class="pre">calib_store</span></tt>, <tt class="docutils literal"><span class="pre">hourly_store</span></tt>, <tt class="docutils literal"><span class="pre">daily_store</span></tt> and <tt class="docutils literal"><span class="pre">monthly_store</span></tt> store processed data (see <a class="reference internal" href="pywws.Process.html"><em>pywws.Process</em></a>). All three are derived from the same <tt class="docutils literal"><span class="pre">core_store</span></tt> class, they only differ in the keys and types of data stored in each record.</p>
</div>
<div class="section" id="module-pywws.DataStore">
<span id="detailed-api"></span><h2>Detailed API<a class="headerlink" href="#module-pywws.DataStore" title="Permalink to this headline">¶</a></h2>
<p>DataStore.py - stores readings in easy to access files</p>
<p>A separate file is used for each day&#8217;s data, to keep memory load
reasonable. One day at a time is held in memory, and saved to disc
when another day needs to be accessed.</p>
<p>Data is accessed in a cross between dictionary and list behaviour.
The following are all valid:
# get value nearest 9:30 on Christmas day
data[data.nearest(datetime(2008, 12, 25, 9, 30))]
# get entire array, equivalent to data[:] or just data
data[datetime.min:datetime.max]
# get last 12 hours of data
data[datetime.utcnow() - timedelta(hours=12):]</p>
<p class="rubric">Functions</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.DataStore.safestrptime" title="pywws.DataStore.safestrptime"><tt class="xref py py-obj docutils literal"><span class="pre">safestrptime</span></tt></a>(date_string[,&nbsp;format])</td>
<td></td>
</tr>
</tbody>
</table>
<p class="rubric">Classes</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.DataStore.data_store" title="pywws.DataStore.data_store"><tt class="xref py py-obj docutils literal"><span class="pre">data_store</span></tt></a>(root_dir)</td>
<td>Stores raw weather station data.</td>
</tr>
<tr><td><a class="reference internal" href="#pywws.DataStore.calib_store" title="pywws.DataStore.calib_store"><tt class="xref py py-obj docutils literal"><span class="pre">calib_store</span></tt></a>(root_dir)</td>
<td>Stores &#8216;calibrated&#8217; weather station data.</td>
</tr>
<tr><td><a class="reference internal" href="#pywws.DataStore.hourly_store" title="pywws.DataStore.hourly_store"><tt class="xref py py-obj docutils literal"><span class="pre">hourly_store</span></tt></a>(root_dir)</td>
<td>Stores hourly summary weather station data.</td>
</tr>
<tr><td><a class="reference internal" href="#pywws.DataStore.daily_store" title="pywws.DataStore.daily_store"><tt class="xref py py-obj docutils literal"><span class="pre">daily_store</span></tt></a>(root_dir)</td>
<td>Stores daily summary weather station data.</td>
</tr>
<tr><td><a class="reference internal" href="#pywws.DataStore.monthly_store" title="pywws.DataStore.monthly_store"><tt class="xref py py-obj docutils literal"><span class="pre">monthly_store</span></tt></a>(root_dir)</td>
<td>Stores monthly summary weather station data.</td>
</tr>
<tr><td><a class="reference internal" href="#pywws.DataStore.core_store" title="pywws.DataStore.core_store"><tt class="xref py py-obj docutils literal"><span class="pre">core_store</span></tt></a>(root_dir)</td>
<td></td>
</tr>
<tr><td><a class="reference internal" href="#pywws.DataStore.params" title="pywws.DataStore.params"><tt class="xref py py-obj docutils literal"><span class="pre">params</span></tt></a>(root_dir)</td>
<td>Parameters are stored in a file &#8220;weather.ini&#8221; in root_dir.</td>
</tr>
</tbody>
</table>
<dl class="function">
<dt id="pywws.DataStore.safestrptime">
<tt class="descclassname">pywws.DataStore.</tt><tt class="descname">safestrptime</tt><big>(</big><em>date_string</em>, <em>format=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#safestrptime"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.safestrptime" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="class">
<dt id="pywws.DataStore.params">
<em class="property">class </em><tt class="descclassname">pywws.DataStore.</tt><tt class="descname">params</tt><big>(</big><em>root_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#params"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.params" title="Permalink to this definition">¶</a></dt>
<dd><p>Parameters are stored in a file &#8220;weather.ini&#8221; in root_dir.</p>
<dl class="method">
<dt id="pywws.DataStore.params.flush">
<tt class="descname">flush</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#params.flush"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.params.flush" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.DataStore.params.get">
<tt class="descname">get</tt><big>(</big><em>section</em>, <em>option</em>, <em>default=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#params.get"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.params.get" title="Permalink to this definition">¶</a></dt>
<dd><p>Get a parameter value and return a string.</p>
<p>If default is specified and section or option are not defined
in the weather.ini file, they are created and set to default,
which is then the return value.</p>
</dd></dl>

<dl class="method">
<dt id="pywws.DataStore.params.get_datetime">
<tt class="descname">get_datetime</tt><big>(</big><em>section</em>, <em>option</em>, <em>default=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#params.get_datetime"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.params.get_datetime" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.DataStore.params.set">
<tt class="descname">set</tt><big>(</big><em>section</em>, <em>option</em>, <em>value</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#params.set"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.params.set" title="Permalink to this definition">¶</a></dt>
<dd><p>Set option in section to string value.</p>
</dd></dl>

</dd></dl>

<dl class="class">
<dt id="pywws.DataStore.core_store">
<em class="property">class </em><tt class="descclassname">pywws.DataStore.</tt><tt class="descname">core_store</tt><big>(</big><em>root_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#core_store"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.core_store" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="pywws.DataStore.core_store.before">
<tt class="descname">before</tt><big>(</big><em>idx</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#core_store.before"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.core_store.before" title="Permalink to this definition">¶</a></dt>
<dd><p>Return datetime of newest existing data record whose
datetime is &lt; idx.</p>
<p>Might not even be in the same year! If no such record exists,
return None.</p>
</dd></dl>

<dl class="method">
<dt id="pywws.DataStore.core_store.after">
<tt class="descname">after</tt><big>(</big><em>idx</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#core_store.after"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.core_store.after" title="Permalink to this definition">¶</a></dt>
<dd><p>Return datetime of oldest existing data record whose
datetime is &gt;= idx.</p>
<p>Might not even be in the same year! If no such record exists,
return None.</p>
</dd></dl>

<dl class="method">
<dt id="pywws.DataStore.core_store.nearest">
<tt class="descname">nearest</tt><big>(</big><em>idx</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#core_store.nearest"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.core_store.nearest" title="Permalink to this definition">¶</a></dt>
<dd><p>Return datetime of record whose datetime is nearest idx.</p>
</dd></dl>

<dl class="method">
<dt id="pywws.DataStore.core_store.flush">
<tt class="descname">flush</tt><big>(</big><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#core_store.flush"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.core_store.flush" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="class">
<dt id="pywws.DataStore.data_store">
<em class="property">class </em><tt class="descclassname">pywws.DataStore.</tt><tt class="descname">data_store</tt><big>(</big><em>root_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#data_store"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.data_store" title="Permalink to this definition">¶</a></dt>
<dd><p>Stores raw weather station data.</p>
</dd></dl>

<dl class="class">
<dt id="pywws.DataStore.calib_store">
<em class="property">class </em><tt class="descclassname">pywws.DataStore.</tt><tt class="descname">calib_store</tt><big>(</big><em>root_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#calib_store"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.calib_store" title="Permalink to this definition">¶</a></dt>
<dd><p>Stores &#8216;calibrated&#8217; weather station data.</p>
</dd></dl>

<dl class="class">
<dt id="pywws.DataStore.hourly_store">
<em class="property">class </em><tt class="descclassname">pywws.DataStore.</tt><tt class="descname">hourly_store</tt><big>(</big><em>root_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#hourly_store"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.hourly_store" title="Permalink to this definition">¶</a></dt>
<dd><p>Stores hourly summary weather station data.</p>
</dd></dl>

<dl class="class">
<dt id="pywws.DataStore.daily_store">
<em class="property">class </em><tt class="descclassname">pywws.DataStore.</tt><tt class="descname">daily_store</tt><big>(</big><em>root_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#daily_store"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.daily_store" title="Permalink to this definition">¶</a></dt>
<dd><p>Stores daily summary weather station data.</p>
</dd></dl>

<dl class="class">
<dt id="pywws.DataStore.monthly_store">
<em class="property">class </em><tt class="descclassname">pywws.DataStore.</tt><tt class="descname">monthly_store</tt><big>(</big><em>root_dir</em><big>)</big><a class="reference internal" href="../_modules/pywws/DataStore.html#monthly_store"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.DataStore.monthly_store" title="Permalink to this definition">¶</a></dt>
<dd><p>Stores monthly summary weather station data.</p>
</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">pywws.DataStore</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a></li>
<li><a class="reference internal" href="#module-pywws.DataStore">Detailed API</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="pywws.device_pyusb.html"
                        title="previous chapter">pywws.device_pyusb</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pywws.TimeZone.html"
                        title="next chapter">pywws.TimeZone</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.TimeZone.html" title="pywws.TimeZone"
             >next</a> |</li>
        <li class="right" >
          <a href="pywws.device_pyusb.html" title="pywws.device_pyusb"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>